package com.usky.gateway.service.utils;

import feign.form.util.CharsetUtil;
import org.springframework.stereotype.Component;

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.nio.charset.Charset;


@Component
public class UdpUtil {

    /**
     * 发送UDP请求并打印返回结果
     *
     * @param requestBytes 要发送的自定义命令
     */
    public static String sendUDPRequest(String host, int port, byte[] requestBytes) {
        try {
            // 创建DatagramSocket随机端口
            DatagramSocket socket = new DatagramSocket();

            // 创建InetAddress对象
            InetAddress address = InetAddress.getByName(host);

            // 创建DatagramPacket，包含发送的数据和目的地
            DatagramPacket OutPacket = new DatagramPacket(requestBytes, requestBytes.length, address, port);

            // 发送DatagramPacket
            socket.send(OutPacket);

            // 创建一个DatagramPacket来接收响应，大小与发送的数据包相同
            DatagramPacket inPacket = new DatagramPacket(requestBytes, requestBytes.length);

            // 接收响应
            socket.receive(inPacket);

            // 打印接收到的数据
            String receivedData = new String(inPacket.getData(), 0, inPacket.getLength(), Charset.forName("ISO-8859-1"));
            System.out.println("接收到的响应： " + receivedData+ ": ");

            // 关闭socket
            socket.close();

            return receivedData;
        } catch (Exception e) {
            e.printStackTrace();
        }

        return null;
    }
}
