package com.usky.hik.service.mqtt.parkRemainSpaceControl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.usky.hik.controller.api.HkVideoApi;
import com.usky.hik.service.config.mqtt.MqttOutConfig;
import com.usky.hik.service.mqtt.MqttStrategy;
import com.usky.hik.service.vo.MqttBaseVO;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Objects;

/**
 * @author zyj
 * @date 2022/12/6 15:07
 */
@Service("parkRemainSpaceControl")
public class parkRemainSpaceControl implements MqttStrategy {
    @Resource
    private MqttOutConfig.MqttGateway mqttGateway;

    /**
     * 查询停车库剩余车位数
     * @return
     */
    public String disposeMessage(MqttBaseVO mqttBaseVO){

        /**
         * 添加请求参数
         */
        JSONObject obj_data = JSONObject.parseObject(mqttBaseVO.getData().toString());
        Integer commandId = Integer.parseInt(obj_data.get("id").toString());
        Object params = JSONObject.toJSONString(obj_data.get("params"));
        JSONObject params_data = JSON.parseObject(params.toString());
        String parkSyscode = params_data.get("parkSyscode").toString();

        String rec_body = HkVideoApi.parkRemainSpace(parkSyscode);

        JSONObject rec_data = JSONObject.parseObject(rec_body);
        String rec_code = rec_data.get("code").toString();

        //推送下发命令响应mqtt
        JSONObject jsonObject = new JSONObject();

        if(rec_code.equals("0")){
            jsonObject.put("result","success");
            jsonObject.put("message",rec_body);

        }else{
            JSONObject obj1 = new JSONObject();
            obj1.put("code",-1);
            obj1.put("message","open failed");
            jsonObject.put("error",obj1);

        }

        jsonObject.put("timeStamp",System.currentTimeMillis());
        jsonObject.put("id",commandId);

        String res_topic = mqttBaseVO.getTopic().replace("control","controlResponse");
        mqttGateway.sendToMqtt(res_topic,jsonObject.toJSONString());

        return null;
    }

}
