package com.usky.hik.service.mqtt.streamControl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hikvision.artemis.sdk.ArtemisHttpUtil;
import com.hikvision.artemis.sdk.config.ArtemisConfig;
import com.usky.hik.controller.api.HkVideoApi;
import com.usky.hik.service.config.mqtt.MqttOutConfig;
import com.usky.hik.service.mqtt.MqttStrategy;
import com.usky.hik.service.utils.ByteUtil;
import com.usky.hik.service.utils.UdpUtil;
import com.usky.hik.service.vo.MqttBaseVO;
import lombok.Data;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.nio.charset.Charset;
import java.util.HashMap;
import java.util.Map;

@Service("streamControl")
@Configuration
@Data
public class streamControl implements MqttStrategy {

    @Resource
    private MqttOutConfig.MqttGateway mqttGateway;

    /**
     * 海康监控系统实时视频预览取流
     * @return
     */
    public String disposeMessage(MqttBaseVO mqttBaseVO){

        /**
         * 添加请求参数
         */
        JSONObject obj_data = JSONObject.parseObject(mqttBaseVO.getData().toString());
        Integer commandId = Integer.parseInt(obj_data.get("id").toString());
        Object params = JSONObject.toJSONString(obj_data.get("params"));
        JSONObject params_data = JSON.parseObject(params.toString());
        String cameraIndexCode = params_data.get("device_id").toString();
        Integer streamType = Integer.parseInt(params_data.get("streamType").toString());
        String protocol = params_data.get("protocol").toString();
        Integer transmode = Integer.parseInt(params_data.get("transmode").toString());
        String expand = "";
        String streamform = "";

        String rec_body = HkVideoApi.getVideoUrl(cameraIndexCode,streamType,protocol,transmode,expand,streamform);
        System.out.println("rec_body: "+rec_body);

        JSONObject rec_data = JSONObject.parseObject(rec_body);
        String rec_code = rec_data.get("code").toString();

        //推送下发命令响应mqtt
        JSONObject jsonObject = new JSONObject();

        if(rec_code.equals("0")){
            jsonObject.put("result","success");
            jsonObject.put("message",rec_body);

        }else{
            JSONObject obj1 = new JSONObject();
            obj1.put("code",-1);
            obj1.put("message","open failed");
            jsonObject.put("error",obj1);

        }

        jsonObject.put("timeStamp",System.currentTimeMillis());
        jsonObject.put("id",commandId);

        String res_topic = mqttBaseVO.getTopic().replace("control","controlResponse");
        mqttGateway.sendToMqtt(res_topic,jsonObject.toJSONString());

        return null;
    }


}
