package com.usky.demo.controller.web;


import com.usky.common.core.bean.ApiResult;
import com.usky.demo.domain.*;
import com.usky.demo.service.QueryInfluxdbDataService;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author ya
 * @since 2024-07-29
 */
@RestController
@Api(tags = "数据统一查询")
@RequestMapping("/dataQuery")
public class QueryInfluxdbDataController {
    @Autowired
    private QueryInfluxdbDataService queryInfluxdbDataService;

    /**
     * 获取设备实时数据(对内)
     * @param requestVO
     * @return
     */
    @PostMapping("/last")
    public ApiResult<List<LastInnerResultVO>> last(@RequestBody LastInnerQueryVO requestVO){
        return ApiResult.success(queryInfluxdbDataService.last(requestVO));
    }

    /**
     * 获取设备历史数据(对内)
     * @param requestVO
     * @return
     */
    @PostMapping("/history")
    public ApiResult<List<HistorysInnerResultVO>> history(@RequestBody HistorysInnerRequestVO requestVO){
        return ApiResult.success(queryInfluxdbDataService.history(requestVO));
    }

    /**
     * 查询influxdb所有表实时数据
     * @return
     */
    @PostMapping("getAllDeviceRealTime")
    public ApiResult<List<Map<String, Object>>> getAllDeviceRealTime(){
        return ApiResult.success(queryInfluxdbDataService.getAllDeviceRealTime());
    }

}

